#!/usr/bin/perl
# Sendmail-to-tnpppage filter
# $Id: from_sendmail_to_tnpppage.pl,v 1.11 1999/11/26 13:10:08 vasim Exp $

use Getopt::Std;

# Place your default TNPP destination here:
$TNPP = "0002";

# Place name of rtnppd's output socket here (external queue must be on):
$socket = "/var/run/rtnppd.queue.out";

# Limits (in chars):
$maxmessagelength = 256;
$maxsubjlength = 32;
$maxfromlength = 32;
$maxtolength = 10;

getopts("t:");
if ("$opt_t" ne "") {
  $TNPP = $opt_t;
}

$to = shift;
if ("$to" eq "") {
  $checkto = 1;
  $to = "(unknown)";
} else {
  $checkto = 0;
}

$from = "(unknown)";
$subject = "(no subject)";
$body = 0;
$mime = 0;
$ignore = 0;
$message = "";
$waitendmime = 0;

while (<>) {
  if ($body) {
    if ($mime) {
      if ($waitendmime) {
	if (/^\r?$/) {
	  $mime = 0;
	}
      } elsif (/^Content-Type: text/i) {
	$waitendmime = 1;
      }
    } else {
      if (/^(.*)\r?$/) {
	$message = "$message$1 ";
        if (length($message) > (1000 + $maxmessagelength)) {
	  goto ENDLOOP;
	}
      }
    }
  } else {
    if (/^\r?$/) {
      $body = 1;
    } elsif (/^[Ff][Rr][Oo][Mm]: (.*)\r?$/) {
      $xfrom = $1;
      if ($xfrom =~ /^.*<(.*)@.*>/) {
	$from = $1;
      } elsif ($xfrom =~ /^.*<(.*)>/) {
	$from = $1;
      } elsif ($xfrom =~ /^(.*)@.*/) {
	$from = $1;
      } else {
	$from = $xfrom;
      }
    } elsif ($checkto && (/^[Tt][Oo]: (.*)\r?$/)) {
      $xto = $1;
      if ($xto =~ /^.*<(.*)@.*>/) {
	$to = $1;
      } elsif ($xto =~ /^.*<(.*)>/) {
	$to = $1;
      } elsif ($xto =~ /^(.*)@.*/) {
	$to = $1;
      } else {
	$to = $xto;
      }
    } elsif (/^[Ss][Uu][Bb][Jj][Ee][Cc][Tt]: (.*)\r?$/) {
      $subject = $1;
    } elsif (/^Content-Type: multipart/i) {
      $mime = 1;
    }
  }
}

ENDLOOP:

$message = substr($message, 0, $maxmessagelength);
#$message =~ tr/'"`/.../;
$message =~ tr/ //s;
$from = substr($from, 0, $maxfromlength);
#$from =~ tr/'"` /..../;
$to = substr($to, 0, $maxtolength);
$to =~ tr/'"` /..../;
$to = lc($to);
$subject = substr($subject, 0, $maxsubjlength);
#$subject =~ tr/'"`/.../;

exec("/usr/local/bin/tnpppage", "-s", $socket, "-t", $TNPP, "-i", $to, "-m", "F:$from S:$subject M:$message");
exit(999);
